# -*- coding: utf-8 -*-
"""
Created on Wed Mar  9 10:39:33 2016

@author: tallakb
"""

import mysql.connector;
import time;
import numpy;
import DBCon3
from random import randint



def avvik_work(kommentar, modellversjon,maksfeil,økninger,diskonteringsrenter,orgnrliste): 
    #Kjører alle [økninger] for en disk.rente, med disk.renter i parallel
    #Kaller finnAvvikFraPerpetuitetsantakelsen for alle økninger og diskonteringsrenter for alle orgnumre i orgnrListe
    id=randint(0,1000)
    failedattempts=0
    allowedattempts=5
    writeUpdate(id," startet kjøring")
    con = mysql.connector.connect(user='*', password='*',host='*', database='*');
    time.sleep(randint(0,3))
    d=orgnrliste
    writeUpdate(id," hentet \t"+ str(len(d)) + " selskaper")
    counter=0
    for e in range(0,len(d)):
        failedattempts=0
        orgnr=d[e][0]
        fulldato=d[e][1]
        dato=fulldato[0:10]
        params = finnAvvikParametre(orgnr,dato)
        for økning in økninger:
            #if e % 100 == 0:print(str(id)+' update: Kjører økning: \t' + str(økning) + '\t for ' + str(kommentar) + ' m.ver:\t' + str(modellversjon) + ' maksfeil:\t' + str(maksfeil) + ' r:\t' + str(diskonteringsrente))
            for diskonteringsrente in diskonteringsrenter:
                    unsuccessful=True
                    while unsuccessful:
                        try:
                            outdict = finnAvvikFraPerpetuitetsantakelsen(orgnr, økning, dato, diskonteringsrente,params)
                            avvik= outdict.get('avvik')
                            nvperp  = outdict.get('deltaperp')
                            nvreell = outdict.get('deltareell')
                            cursor = con.cursor();
                            query=("INSERT INTO avvik VALUES (null, %s, %s, %s, %s, %s, %s, %s, %s, %s, %s);")
                            cursor.execute(query, (orgnr, avvik, økning, dato, modellversjon, kommentar, maksfeil, diskonteringsrente+1,nvperp,nvreell)); 
                            cursor.close();
                            con.commit();
                            unsuccessful=False
                            #print('seems to be working')
                        except Exception as exc:
                            print(exc)    
                            unsuccessful=True
                            failedattempts+=1
                            if failedattempts>=allowedattempts:
                                 writeUpdate(id,"\t feil for orgnr \t" + str(orgnr) + "\t exception: \t" + str(exc) + "\t i avvik_work, attempt number \t" + str(failedattempts) + "\t !!! Aborting and moving on")
                                 unsuccessful=False
                            else:     
                                 writeUpdate(id,"\t feil for orgnr \t" + str(orgnr) + "\t exception: \t" + str(exc) + "\t i avvik_work, attempt number \t" + str(failedattempts)) 
                                 time.sleep(randint(5,15))
                            print('Failed - venter, e: ' + str(e))
                            
        counter+=1
        if counter % 100 == 0: writeUpdate(str(id)," har kjørt: \t"+str(counter))
        
    con.close(); 
    writeUpdate(id," avsluttet kjøring")
    

def writeUpdate(orgnr, message): #Skriver oppdatering av kjørestatus til fil 
        with open("finnAvvikRunning.txt", "a") as myfile:
                writeString="orgnr:\t"+str(orgnr)+'\t'+str(message)+'\r\n'
                myfile.write(writeString)

def printVarArray(name, varname, fra, til):
        outputstr="" 
        delimeter="\t" #tab-delimeted
        outputstr=varname
        for i in range(fra, til):
                temp=name[i]
                if(temp==0):
                    outputstr=outputstr + delimeter + "       0"
                else:
                    l=len(str(temp))
                    streng=""
                    while(l<8):
                        streng=streng+" ";
                        l+=1
                    
                    outputstr=outputstr + delimeter +streng+ str(round(temp,5))
               
        return outputstr



def kalkulerSkatteskjoldVerdi(nomineltSkjold,førSkattFørSkjoldKontantstrøm,diskonteringsFaktorer,skatteSats): #Returns NPV of a tax shield shielding a given cash flow, with tax credits accumulating against future results and used in T+1, 0 carrybacks,
    #nomineltSkjold er den nominelle maksimale reduksjonen i førSkattFørSkjoldKontantstrøm
    #førSkattFørSkjoldKontantstrøm antas å være EKSKLUSIVE-nomineltSkjold on input (!)
    #diskonteringsFaktorer antas prekalkulert, i.e. avkastningskrav på 10% skal gis som en inputliste a la [1.1, 1.121, 1.331, ...] 
    #Merk: fullt (altså perpetuitetsantatt) nomineltSkjold kan kalkuleres ved å kalle funksjonen med førSkattFørSkjoldKontantstrøm=nomineltSkjold
    #Alt ubrukt skatteskjold antas brukt i T+1 med diskonteringsfaktor = discRate[i]^2/discRate[i-1] (i.e. med neste diskonteringsfaktor med avkastningskravet som impliseres av de to siste faktorene) og med neste års skattesats (SKT MÅ HA STØRRELSEN antÅR+1)
    if len(nomineltSkjold)!=len(førSkattFørSkjoldKontantstrøm):
        print("Error in tax shield array sizing!")
        print("Nom: "+str(len(nomineltSkjold))+" \t cf: " +str(len(førSkattFørSkjoldKontantstrøm)))
        exit

    taxShieldUsed=[]
    shieldValue=[]
    unusedShield=0
    for i in range(0,len(nomineltSkjold)):
        usedShield=min(max(førSkattFørSkjoldKontantstrøm[i],0),nomineltSkjold[i]+unusedShield)
        unusedShield=nomineltSkjold[i]+unusedShield-usedShield     
        taxShieldUsed.append(usedShield)
        shieldValue.append(usedShield/diskonteringsFaktorer[i]*skatteSats[i])
        #print("kalkskjold bruktSkjol i år" + str(i) + " " + str(usedShield))
        #print("kalkskjold ubruktSkjol i år" + str(i) + " " + str(unusedShield))
        #print("kalkskjold bruktSkjol i år" + str(i) + " " + str(usedShield))
    return sum(shieldValue) + unusedShield*skatteSats[i+1]/(diskonteringsFaktorer[i]**2/diskonteringsFaktorer[i-1])
    




def finnAvvikFraPerpetuitetsantakelsen(orgnummer, økning, dato, diskonteringsrente, inputdict={}, future=False, sim=False,antÅr=14):
    #print(inputdict)
    #Hent parametre inputdict og initialiser variabler
    if(not future and sim and inputdict!={}):
        eRFU= inputdict.get('eRFU') # Dette er før fremførbart underskudd
        eSRE= inputdict.get('eSRE') # Dette er etter fremførbart underskudd #Trengs ikke!? 
        eFRU= [0]#inputdict.get('eFRU') #fremførbart underskudd
        AVS0= inputdict.get('AVS0DB') #Avskrivninger fra de forskjellige klassene. [Array fra finnAvvikParametre]
        AVS1= inputdict.get('AVS1DB')
        AVS2= inputdict.get('AVS2DB')
        AVS3= inputdict.get('AVS3DB')
    elif(future and sim and inputdict!={}):
        eRFU= inputdict.get('eRFU') # Dette er før fremførbart underskudd
        #print(eRFU)
        eSRE= inputdict.get('eSRE') # Dette er etter fremførbart underskudd #Trengs ikke!? 
        eFRU= inputdict.get('eFRU') #fremførbart underskudd
        AVS0= inputdict.get('AVS0') #Avskrivninger fra de forskjellige klassene. 
        AVS1= inputdict.get('AVS1')
        AVS2= inputdict.get('AVS2')
        AVS3= inputdict.get('AVS3')                
    else:
        if inputdict=={}:
            inputdict = finnAvvikParametre(orgnummer,dato)
        eRFU= inputdict.get('eRFU') # Dette er før fremførbart underskudd
        eSRE= inputdict.get('eSRE') # Dette er etter fremførbart underskudd #Trengs ikke!? 
        eFRU= inputdict.get('eFRU') #fremførbart underskudd
        AVS0= inputdict.get('AVS0') #Avskrivninger fra de forskjellige klassene. 
        AVS1= inputdict.get('AVS1')
        AVS2= inputdict.get('AVS2')
        AVS3= inputdict.get('AVS3')   
        #print('geter param')
#    elif inputdict.get('error')!=None: return -1 
        

    SR = [0]*antÅr          #Skatteresultat før avskrivninger før fremførbart underskudd
    SSR = [0]*antÅr         #Sum skatteresultat, altså inkludert inngående fremførbart underskudd, men ikke avskrivninger
    AVSK=[0]*antÅr;         #Sum avskrivninger
    AVSKOrig=[0]*antÅr      #Sum avskrivninger som stammer fra original saldobalanse
    AVSKOrigØkt=[0]*antÅr   #Sum avskrivininger som stammer fra original saldobalanse økt med faktoren 'økning' - proxy for markedsmessige saldoverdier
    invAVS=[0]*antÅr        #Sum avskrivninger som stammer fra investeringer - dvs fra annet enn den originale saldobalansen
    initAVSK=[[0]*antÅr,[0]*antÅr,[0]*antÅr,[0]*antÅr]
    IFU=[0]*antÅr;          #Innkommende fremførbart underskudd som ikke kommer av avskrivninger
    #print('eRFU i finnAvvik \t' + str(eRFU))

    #Sett beregningsparametre
    ASAV=[  #Avskrivningssats
        [0.2,0.15,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2,0.2],             #d-inventar, 2001-2014
        [0.02,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04,0.04],#h-4bygg, 2001-2014
        [0,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02,0.02],   #i-2bygg, 2001-2014
        [0,0,0,0,0,0,0,0.10,0.10,0.10,0.10,0.10,0.10,0.10]                      #j-teknisk, 2001-2014
        ] 
    SKT=[0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.28,0.27,0.27,0.25,0.235,0.22] #Obs, listen er årene 2001-2018, inklusive, for 2017 og 2018 er skatten satt til hhv 23.5% og 22% i tråd med Regjeringens uttalelser om reduksjon av selskapsskatt, merk at skattesatsen for NESTE år må være med, ifm.evt. beregning av effekt på utsatt skatt/-fordelSum avskrivininger som stammer fra original saldobalanse økt med faktoren 'økning' - proxy for markedsmessige saldoverdier
    invAVS=[0]*antÅr        #Sum avskrivninger som stammer fra investeringer - dvs fra annet enn den originale saldobalansen
    initAVSK=[[0]*antÅr,[0]*antÅr,[0]*antÅr,[0]*antÅr]
    IFU=[0]*antÅr;          #Innkommende fremførbart underskudd som ikke kommer av avskrivninger

    #Sett beregningsparametre
    if future: #Simuleringsberegning av avvik - vi skal bruke siste års avskrivningssatser, og foreslåtte skattesatser
            ASAVtmp=[  #Avskrivningssats
                [ASAV[0][13] for x in range(0,antÅr)],             #d-inventar, 2001-2014
                [ASAV[1][13] for x in range(0,antÅr)],#h-4bygg, 2001-2014
                [ASAV[2][13] for x in range(0,antÅr)],   #i-2bygg, 2001-2014
                [ASAV[3][13] for x in range(0,antÅr)]                      #j-teknisk, 2001-2014
                ] 
            SKTtmp=[0.27,0.25,0.235,0.22] + [SKT[17] for x in range(0,antÅr)] #Obs, listen er årene 2015-2018, inklusive, for 2017 og 2018 er skatten satt til hhv 23.5% og 22% i tråd med Regjeringens uttalelser om reduksjon av selskapsskatt, merk at skattesatsen for NESTE år må være med, ifm.evt. beregning av effekt på utsatt skatt/-fordel
            #SKTtmp=[.28]*18
            ASAV=[]
            SKT=[]
            ASAV=ASAVtmp
            SKT=SKTtmp
            
    firstYear=-1 #Første år med tall for byggsaldo
    
    for t in range(0,antÅr): #Finn startår for byggsaldo - dette brukes for å sette UBB saldoer å beregne mindreavsk.fradrag av
        if (AVS1[t]!=0 or AVS2[t]!=0) and firstYear==-1:
            firstYear=t
            initAVSK[0][t]=AVS0[t]
            initAVSK[1][t]=AVS1[t]
            initAVSK[2][t]=AVS2[t]
            initAVSK[3][t]=AVS3[t]
            if (initAVSK[0][t]+initAVSK[1][t]+initAVSK[2][t]+initAVSK[3][t])==0: print('problem')
        #Beregn totalte avskrivninger
        AVSK[t]=AVS0[t]+AVS1[t]+AVS2[t]+AVS3[t]
    if firstYear==-1:
            print('start-år ikke satt for selskap :\t'+str(orgnummer))
            return
    
    #Beregn avskrivninger fra initiell saldobalanse - m.avsk.fradrag skal kompensere for de eksisterende saldoverdiene, ink. evt. fordeling til j-Tekniske Installasjoner, men altså eks. s.avsk fra investeringer, og med faktorøkning
    for t in range(firstYear,antÅr):
        if firstYear<8 and t==8 and not future:#Dersom startåret er før 2009 skal UB byggsaldo_initiell 2008 fordeles 40% til tekniske installasjoner
                initAVSK[3][t]=0.4*(initAVSK[1][t]/ASAV[1][t]+initAVSK[2][t]/ASAV[2][t])*ASAV[3][t]
                initAVSK[1][t]=0.6*initAVSK[1][t]
                initAVSK[2][t]=0.6*initAVSK[2][t]
                
        AVSKOrig[t]=(initAVSK[0][t]+initAVSK[1][t]+initAVSK[2][t]+initAVSK[3][t]) #De originale avskrivningene fra init balanse
        AVSKOrigØkt[t]=(AVSKOrig[t] * (1+ økning)) #Originale avskrv. fra init balanse økt med faktor 'økning'

        for k in range(0,4):
            if t!=antÅr-1:
                initAVSK[k][t+1] = (1-ASAV[k][t])*initAVSK[k][t]
    

    #Beregn kontantstrøm som skal skjermes      
    for t in range(0,antÅr):
        #Beregn saldoavskrivninger som kommer fra investeringer, som ikke skal gi m.avsk.fradrag
        invAVS[t] = AVSK[t] - initAVSK[0][t]- initAVSK[1][t]- initAVSK[2][t]- initAVSK[3][t]
        #Beregn årets skatteresultat før avskrivninger og fremførbart underskudd
        SR[t]=eRFU[t]+AVSK[t]-invAVS[t] #Skatteresultat for selskapet før fremførbart underskudd og relevante avskrivninger (altså res. før fremf underskudd og avskrivninger fra initiell saldobalanse (mao. er investerte saldoavskrivninger ansett som eksogen på lik linje med skatteres.)
        #Beregn fremførbart underskudd som stammer fra underliggende drift, mao. fremf.und. som ikke stammer fra saldoavskrivninger av initiell saldobalanse
        if(t>0):
            IFU[t]=min(SSR[t-1],0); #Første år er innkommende fremførbart underskudd fra andre ting enn avskrivninger 0, ellers forrige års SSR
        SSR[t]=SR[t]+IFU[t]
    #print('SSR \t'+str(SSR))
    #Beregn avvik i verdsettelse av mindreavskrivningsfradraget
    diskonteringsFaktorer = [(1+diskonteringsrente)**x for x in range(0,antÅr)]
    if økning == 0: #Avvik i perpetuitetsantakelsen - spesialtilfelle der økt saldo = original saldo (økning = 0) og avvik i m.avsk.fradrag kun er forskyvning av skatteeffekt av eksisterende saldoavskrivninger
        perp=kalkulerSkatteskjoldVerdi(AVSKOrig,AVSKOrig,diskonteringsFaktorer,SKT) #Perp.antatt skatteskjold der avskrivningene brukes opp hvert år 
        reell=kalkulerSkatteskjoldVerdi(AVSKOrig,SSR,diskonteringsFaktorer,SKT)     #Reelt skatteskjold, der avskrivningene IKKE brukes opp hvert år
        avvik = 1 - reell/perp #Relativt avvik i %
        delta_reell=reell
        delta_perp=perp
    elif økning != 0: #Avvik i m.avsk.fradrag - økt saldo <> original saldo, og relativt avvik er FORANDRING i reelt skatteskjold mot FORANDRING i perpetuitetsskatteskjold
        #print("økt-perp",kalkulerSkatteskjoldVerdi(AVSKOrigØkt,AVSKOrigØkt,diskonteringsFaktorer,SKT))
        #print("orig-perp",kalkulerSkatteskjoldVerdi(AVSKOrig,AVSKOrig,diskonteringsFaktorer,SKT))
        #print("disko",diskonteringsFaktorer)
        #print(AVSKOrig)
        #print('orig reell',str(kalkulerSkatteskjoldVerdi(AVSKOrig,SSR,diskonteringsFaktorer,SKT)))
        #print(AVSKOrigØkt)
        #print('økt reell',str(kalkulerSkatteskjoldVerdi(AVSKOrigØkt,SSR,diskonteringsFaktorer,SKT)))
        delta_perp = kalkulerSkatteskjoldVerdi(AVSKOrigØkt,AVSKOrigØkt,diskonteringsFaktorer,SKT) - kalkulerSkatteskjoldVerdi(AVSKOrig,AVSKOrig,diskonteringsFaktorer,SKT)
        delta_reell = kalkulerSkatteskjoldVerdi(AVSKOrigØkt,SSR,diskonteringsFaktorer,SKT) - kalkulerSkatteskjoldVerdi(AVSKOrig,SSR,diskonteringsFaktorer,SKT)
        if delta_perp!=0:
            avvik = 1 - delta_reell/delta_perp
        else:
            avvik = 0
            print('Feil i beregning av avvik for selskap \t' + str(orgnummer) +'\t delta_perp ga div-0 mens delta_reell var \t' + str(delta_reell))
    outdict={'deltaperp':delta_perp,'deltareell':delta_reell,'avvik':avvik}
   
    return outdict



def finnAvvikParametre(orgnummer,dato): #Henter ut regnskapsparametre som skal brukes til å beregne avvik fra databasen
    failedattempts=0
    allowedattempts=10
    unsuccessfulGet=True
    while unsuccessfulGet:
        try:
            returndict={
                'eRFU':list(DBCon3.hentEstimater(orgnummer,dato, "eRFU")[0][3:17]),  # Dette er før fremførbart underskudd
                'eSRE':list(DBCon3.hentEstimater(orgnummer,dato, "eSRE")[0][3:17]),  # Dette er etter fremførbart underskudd #Trengs ikke!? 
                'eFRU':list(DBCon3.hentEstimater(orgnummer,dato, "eFRU")[0][3:17]),  # Fremførbart underskudd
                'AVS0':list(DBCon3.hentEstimater(orgnummer,dato, "eAVS0")[0][3:17]), # Avskrivninger fra de forskjellige klassene. 
                'AVS1':list(DBCon3.hentEstimater(orgnummer,dato, "eAVS1")[0][3:17]),
                'AVS2':list(DBCon3.hentEstimater(orgnummer,dato, "eAVS2")[0][3:17]),
                'AVS3':list(DBCon3.hentEstimater(orgnummer,dato, "eAVS3")[0][3:17])
            }
            unsuccessfulGet=False
        except Exception as excL:
            writeUpdate(id,"\t feil for orgnr \t" + str(orgnummer) + "\t exception: \t" + str(excL) + "\t i finnAvvikParametre") 
            print(excL)
            time.sleep(randint(15,35))
            print('Failed at getting estimates for orgnr:\t'+str(orgnummer))
            unsuccessfulGet=True
            failedattempts+=1
            if failedattempts>=allowedattempts:
                unsuccessfulGet=False
                returndict={'error':'feilet i å hente estimater fra databasen i FinnAvvik.finnAvvikParametre'}
    return returndict
