<?php

class DatabaseConnector
{
    /** @var $mysqli mysqli */
    private $mysqli;
    private $host = "CHANGE ME";
    private $username = 'CHANGE ME';
    private $password = "CHANGE ME";
    private $schema = "CHANGE ME";

    public function __construct()
    {
        $this->mysqli = new mysqli($this->host, $this->username, $this->password, $this->schema);
        if ($this->mysqli->connect_errno) {
            throw new Exception("Connect failed: " .$this->mysqli->connect_error);
        }
    }

    public function query($query)
    {
        $result = $this->mysqli->query($query);
        if (!$result) {
            throw new Exception("Query failed: " .$this->mysqli->error);
        }
        return $result;
    }

    public function getLastInsertedId()
    {
        return $this->mysqli->insert_id;
    }

    public function close()
    {
        if ($this->mysqli) {
            $this->mysqli->close();
        }
    }
}