# -*- coding: utf-8 -*-
"""
Created on Thu Feb 4 14:32:20 2016

@author: tallakb
"""

#År
maxT=13
minT=0

def beregnRisikoMåltall(orgnummer):
    
    EBITDA = ['x' for x in range(minT,maxT+1)]
    DeltaEBITDA = [0 for x in range(minT,maxT+1)]
    driftsresultat=padData(hentPostVerdier("Driftsresultat",orgnummer))
    avskrivninger = padData(hentPostVerdier("Avskrivning på varige driftsmidl",orgnummer))
    nedskrivninger = padData(hentSumNedskrivninger(orgnummer))
    driftsinntekter = padDataNaN(hentDriftsInntekter(orgnummer))
    startår=0
    #Må finne startår.     
    for i in range(minT,maxT+1):
        if (driftsinntekter[i]=='NaN'):
            startår=i+1
            #print("Vi er i år ",i)
        else:
           # print("Vi breaker i år ",i)            
            break

    if startår>12:
        return 'NaN'
    for x in range(minT,maxT+1):
        if(driftsinntekter[x]!='NaN'):
            EBITDA[x]=(driftsresultat[x]+avskrivninger[x]+nedskrivninger[x])/driftsinntekter[x]
        else:
            EBITDA[x]='NaN'
   
    for x in range(minT+1,maxT+1):
        if(EBITDA[x-1]==0):
            DeltaEBITDA[x]=EBITDA[x]
        else:
            DeltaEBITDA[x]=EBITDA[x]/EBITDA[x-1]
    print(EBITDA)
    print(DeltaEBITDA)   
    
    #Returnerer standardavviket i EBITDA-margin for selskapet
    return np.std(DeltaEBITDA[startår:])
    
    

    
def beregnAlleRisikoTall(kjørekommentar, lagre=False):
    con = mysql.connector.connect(user='*', password='*',host='*', database='*');
    måltallListe=[]
    for i in range(1,200):
        print("i:",i)
        cursor = con.cursor();
        query = ("INSERT INTO risikoklassifisering VALUES (null,%s, %s, %s,null,%s);");   
        orgnumre= hentOrgNumre(800000000+i*1000000,801000000+i*1000000)
        unsuccessful=True
        
        while(unsuccessful):
            try: 
                for orgnummer in orgnumre:
                    måltall=beregnRisikoMåltall(orgnummer[0])
                    if (måltall!='NaN' and not lagre):
                        måltallListe.append(måltall) #For bruk i datavalidering
                    #print(orgnummer, måltall)
                    if (måltall!='NaN' and lagre):
                        cursor.execute(query, (orgnummer[0], "stdEBITDA", float(måltall),kjørekommentar));

                if(lagre):
                    cursor.close();
                    con.commit();           
                unsuccessful=False
            except Exception as e:
                #Feilhåndtering pga for stor belastning på nettverket
                print(e)
                time.sleep(60)
    
    con.close();   
    return måltallListe;    
    
    
def padData(inputdict): #Tar database-dictionary med år-nøkler og pad'er til 0-indeksert 2001
        outputlist=[ 0 for x in range(minT,maxT+1)]
        #print (inputdict)
        for i in range(minT,maxT+1):
                outputlist[i]=inputdict.get(2001+i) if not inputdict.get(2001+i)==None else 0
        return outputlist
        
def padDataNaN(inputdict): #Tar database-dictionary med år-nøkler og pad'er til 0-indeksert 2001
        outputlist=['NaN' for x in range(minT,maxT+1)]
        #print (inputdict)
        for i in range(minT,maxT+1):
                outputlist[i]=inputdict.get(2001+i) if not inputdict.get(2001+i)==None else 'NaN'
        return outputlist